//
//  DTCArrayExtensions.h
//  Dragoman
//
//  Created by Philipp on 5/11/08.
//  Copyright 2008 Dare to be Creative Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSArray (DTCArrayExtensions)

#pragma mark Functional-like methods

// Creates a new array by collecting the return value of passing aSelector message to each element
-(NSArray *)map:(SEL)aSelector;

// Like map but sends aSelector message with anObject as argument
-(NSArray *)map:(SEL)aSelector withObject:(id)anObject;


#pragma mark String array methods

// Remove duplicate strings from array ignoring case
- (NSArray *) removeDuplicatesIgnoringCase;


#pragma mark Filename methods

// Returns only the path extension from a filename (NSString) array
-(NSArray *)pathExtensions;

// Swap extensions
-(NSArray *)swapExtensions:(NSString *)newExtensions;

// Determines whether the array (of filenames) all have one of the given file extensions
-(BOOL) belongToTypes:(NSArray *)anExtensionList;

-(BOOL) belongToSameType;

@end
