//
//  UniqueDestination.h
//  iArchive
//
//  Created by Philipp on 06/10/2007.
//  Copyright 2007 Dare to be Creative Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSFileManager (UniqueDestination)

/*
 * Finds a unique destination for a filename in a given destination
 *
 * If no file with "filename" exists in "directory", then this is returned.
 *
 * If a file with "filename" does exist, then "filename 2" is returned. If "filename 2" already exists
 * then "filename 3" is returned, and so on.
 *
 * This method is intended to mimic Finder when extracting archives.
 */
- (NSString *)findUniqueDestinationForFile:(NSString *)filename inDirectory:(NSString *)directory;

@end
