//
//  AbstractApplicationController.h
//  DTCRegistration
//
//  Created by Philipp Mayerhofer on 3/15/08.
//  Copyright 2008 Dare to be Creative Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "RegistrationController.h"

/*
 * Provides common methods for application controllers using the registration panel
 */
@interface AbstractApplicationController : NSObject {
	RegistrationController *registrationController;
}

// Accessor methods for the registration controller
- (RegistrationController *) registrationController;
- (void) setRegistrationController: (RegistrationController *)aRegistrationController;

// Calls buy application dialogue
- (IBAction) buyApplication:(id)sender;

// Calls register application dialogue
- (IBAction) registerApplication:(id)sender;

@end
